#!/bin/sh
# Script excut par l'application '/usr/bin/immediat.pl'
# on regarde quel est l'etat du chauffage actuellement afin
# de ragir differemment si nous sommes deja en ejp ou en blanc
# puis on prepare la crontab pour passer en mode blanc

# on sauve la crontab
/usr/bin/crontab -u dom -l > /var/tmp/crontab-base

# Efface la crontab -u dom du mode programmateur
/usr/bin/crontab -u dom -u dom -r >> /dev/null 2>&1

# on regarde si l'on n'est dj en mode blanc ou non:
if [ -e /var/tmp/blanc.lock ]
then
  # nous sommes dj en blanc, on poursuit ce mode
  /usr/bin/crontab -u dom -u dom /etc/chauffage.conf/cont-blanc.cron
else
  # Nous sommes soit en ejp, soit en rien du tout
  if [ -e /var/tmp/ejp.lock ]
  then
    # nous sommes dj en mode ejp, on vire le lock de l'ejp
    /usr/bin/sudo /bin/rm /var/tmp/ejp.lock
    # et on installe la crontab de relais ejp -> blanc
    /usr/bin/crontab -u dom -u dom /etc/chauffage.conf/pre-ejp_vers_blanc.cron
  else
    # nous sommes en mode normal.
    # Installe la crontab -u dom en mode pr-BLANC
    /usr/bin/crontab -u dom -u dom /etc/chauffage.conf/pre-blanc.cron
  fi
  /bin/touch /var/tmp/blanc.lock
fi
