#!/bin/sh
# Script excut par l'application '/usr/bin/immediat.pl'
# on regarde quel est l'etat du chauffage actuellement afin
# de ragir differemment si nous sommes deja en ejp ou en blanc
# puis on prepare la crontab pour passer en mode ejp

# on sauve la crontab
/usr/bin/crontab -u dom -l > /var/tmp/crontab-base

# Efface la crontab -u dom du mode programmateur
/usr/bin/crontab -u dom -r >> /dev/null 2>&1

# on regarde si l'on n'est dj en ejp ou non:
if [ -e /var/tmp/ejp.lock ]
then
  # nous sommes dj en ejp, on poursuit ce mode
  /usr/bin/crontab -u dom /etc/chauffage.conf/cont-ejp.cron
else
  # sommes nous deja en mode blanc?
  if [ -e /var/tmp/blanc.lock ]
  then
    # oui, nous sommes deja en mode blanc, on passe donc en ejp
    /usr/bin/sudo /bin/rm /var/tmp/blanc.lock
    /usr/bin/crontab -u dom -u dom /etc/chauffage.conf/pre-blanc_vers_ejp.cron
  else
    # non, pas de mode blanc avant, donc on 
    # installe la crontab -u dom en mode pr-EJP
    /bin/touch /var/tmp/ejp.lock
    /usr/bin/crontab -u dom /etc/chauffage.conf/pre-ejp.cron
  fi
fi
