#!/usr/bin/perl -w
# Par R. Suinot, le 01/10/2000
# Revision: 02/01/2002

$Version="0.2.0102";

# ------------------------------------------------------------------------------
# En complment de l'archive 'heather' par Dominique Laigle (email: lainal@gmx.de)
# L'app attend une touche pour couper un groupe de chauffage ou le remettre en route.
# Elle est prvue pour tourner en boucle, mais sans cran ni en tache de fond.
# Elle peut (doit) etre installee avec le programme lanceur.c, avec modification
# le fichier d'initialisation /etc/inittab
# (Surtout pas en tache de fond, sinon, il n'y aura JAMAIS de gestion du clavier)
# => voir fichier Raide-mi!
# ------------------------------------------------------------------------------

use Term::ReadKey;
# Limite de temps entre chaque raffichage de l'tat des radiateurs (en secondes)
$timeout=10;

# Dfinition des fichiers utilis. ---------------------------------------------
$Fi_status     = "/var/tmp/gheather.status";
$Fi_lock       = "/var/tmp/immediat";   # Fichier lock pour immediat.pl
$Fi_lock_ejp   = "/var/tmp/ejp.lock";   # Fichier lock pour le mode ejp
$Fi_lock_blanc = "/var/tmp/blanc.lock"; # Fichier lock pour le mode blanc
$Fi_touches    = "/etc/chauffage.conf/touches.conf"; # Fichier de definitions des touches/actions/bruit
$Fi_erreurs    = "/etc/chauffage.conf/erreurs.txt";  # Fichiers des messages d'erreurs/info
$Fi_messages   = "/etc/chauffage.conf/messages.txt"; # Fichier de textes d'ordre gnral

# ------------------------------------------------------------------------------
# En premier, on verifie qu'il n'y a pas dj un processus  identique en cours
# si oui -> on previent
# si non -> on met un fichier lock dans /tmp/

if (-e $Fi_lock ) { 
   print "ATTENTION: un processus est dj en cours!\n";
}

# ------------------------------------------------------------------------------
# Dfinition des divers variables et tableaux
$etat=0;   # Variable d'etat, pour traiter les touches en
           # fonction du contexte.(voir fichier etat.txt)
$ancien_etat=0; # sauvegarde de $etat


$flag_err = 0; # N de message d'erreurs  afficher;
# $flag_mes = 0; # N de message gnral  afficher;

@erreurs  = () ;
@messages = () ;
@clavier  = ();

# Tous les fichiers sont lu, on passe au fichier lock.
open (FL, ">$Fi_lock") or die "Impossible de crer le fichier lock.\n";
close (FL);

# @action=("0", "", "", ""); # sauvegarde des actions a effectuer,
                          # action[1]= nombres d'actions
@tab=("0", "", "", ""); # tableau pour les actions/durees

#------- Appels aux fonctions ---------------------------------------------- 
&lectureconf();
&lecturemessages();
&lecturerreurs();
&info();

#-------------------------------------------------------------------------------
# On change le mode de travail du clavier
open (IN, "</dev/tty");
*IN=*IN;

ReadMode 4, IN;

# ------------------------------------------------------------------------------
# on dbute la boucle sans fin
my $i = 0;    # flag de sortie de boucle
do
{
   &touche();  # Ici, on attend l'appui sur une touche

   # a partir d'ici, il va falloir tester tous les caractres.
   if ( $key eq $clavier[0] ) {
      # Si touche 'escape', on remet la variable $etat a ZERO
      $etat=0;
   } elsif ( $key =~ /[$clavier[3]]/ ) {
      # Liste des commandes, svp.
      &commande();
      print "\n";
   } else {
      # A present, on traite en fonction de $etat
      if ( $etat == 0 ) {
         # Ah! qu'a t on demande a faire?
         &attend_char ( $key );
         &info();
      } elsif ( $etat == 1 ) {
         # on veut quitter?
         if ($key =~ /[$clavier[2]]/ ) {
            $i++;
         } else {
            $i=0;
            system("/usr/bin/beep", -f3000, -l200, -r1 );
            $etat=0;
            &info();
         }
      } elsif ( $etat == 2 ) {
         # nous avons une touche, si c'est une action, c'est bon
         # sinon, on repasse $etat a 0 (sauf si c'est '+' )
         &attend_char ($key);
         if ( $tab[0] =~ /[0]/ ) {
            # Pas d'action, donc on repasse a 0
            $etat=0;
         } else {
            # Ok, on attend la duree
            $etat=3;
         }
         &info();
      } elsif ( $etat == 3 ) {
         # Cette fois ci, on a la duree (mais verifions d'abord!)
         if ( $key =~ /[1-9]/ ) {
#           $erreur="ok, c'est bon: action + duree! \n";
            $flag_err = 0;
         } else {
#           $erreur="Ah, non, erreur...     :( \n";
            $flag_err = 1;
         }
         $etat=0;
         &info();
      } elsif ( $etat == 4 ) {
	 # Demande de reaffichage de l'tat des radiateurs
         &info();
	 $etat=$ancien_etat;
      }
   }
}
while ( !$i );            # Recommence tant que $i = 0

# Normalement, nous ne devrions JAMAIS arriver ici
# puisque le programme tourne en boucle, et de 
# toute facon init le relance comme une console ( cf: /etc/inittab )

ReadMode "normal";

# Supression du fichier lock
unlink ( $Fi_lock );

# et on quitte! Salut!
exit 0;

# ------------------------------------------------------------------------------
# A partir d'ici commence les fonctions
sub attend_char
{
   if ( $_[0] =~ /[$clavier[4]]/ ) {
   # Passage en mode OFF du groupe de convecteur n 1
      system("/usr/bin/heathout", 1, "off" );
      system("/usr/bin/beep", -f1000, -l100, -r5 );
      $tab[0]=2;;

   } elsif ( $_[0] =~ /[$clavier[5]]/ ) {
   # Passage en mode OFF du groupe de convecteur n 2
      system("/usr/bin/heathout", 2, "off" );
      system("/usr/bin/beep", -f1000, -l100, -r5 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[6]]/ ) {
   # Passage en mode OFF du groupe de convecteur n 3
      system("/usr/bin/heathout", 3, "off" );
      system("/usr/bin/beep", -f1000, -l100, -r5 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[7]]/ ) {
   # Passage en mode OFF du groupe de convecteur n 4
      system("/usr/bin/heathout", 4, "off" );
      system("/usr/bin/beep", -f1000, -l100, -r5 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[8]]/ ) {
   # Passage en mode ON du groupe de convecteur n 1
      system("/usr/bin/heathout", 1, "on");
      system("/usr/bin/beep", -f1000, -l50, -r1 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[9]]/ ) {
   # Passage en mode ON du groupe de convecteur n 2
      system("/usr/bin/heathout", 2, "on");
      system("/usr/bin/beep", -f1000, -l50, -r2 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[10]]/ ) {
   # Passage en mode ON du groupe de convecteur n 3
      system("/usr/bin/heathout", 3, "on");
      system("/usr/bin/beep", -f1000, -l50, -r3 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[11]]/ ) {
   # Passage en mode ON du groupe de convecteur n 4
      system("/usr/bin/heathout", 4, "on");
      system("/usr/bin/beep", -f1000, -l50, -r4 );
      $tab[0]=2;

   } elsif ( $_[0] =~ /[$clavier[12]]/ ) {
   # Passage en horaire Blanc: coupe tout jusqu'a 16h
      system("/bin/sh /usr/local/bin/chauffage/pre-blanc.sh" );
      system("/usr/bin/beep", -f1000, -l50, -r10 );
      $tab[0]=2;
      $etat=0;

   } elsif ( $_[0] =~ /[$clavier[13]]/ ) {
   # Passage en horaire Rouge: coupe tout!
      system("/bin/sh /usr/local/bin/chauffage/pre-ejp.sh");
      system("/usr/bin/beep", -f1000, -l50, -r10 );
      $tab[0]=2;
      $etat=0;
#     $erreur="Attention: Red Alert!!!!!!!!!!! ";
      $flag_err = 2;

   } elsif ( $_[0] =~ /[$clavier[14]]/ ) {
   # On demandera le temps de changement de programmation
      system("/usr/bin/beep", -f1000, -l50, -r1 );
      $etat=2;
#     $erreur="Entrez d'abord l'action, puis la dure de celle ci (entre 1h et 9h)";
      $flag_err = 3;

   } elsif ( $_[0] =~ /$clavier[15]/ ) {
   # Erreur, touche non traite.
      system("/usr/bin/beep", -f900, -l50, -r1 );
      system("/usr/bin/beep", -f900, -l50, -r1 );
      system("/usr/bin/beep", -f900, -l50, -r1 );
      $etat=0;
#     $erreur="Dsol, je ne comprend pas.";
      $flag_err = 4;
   }
}     

sub commande
{
   system("clear");   # equ 'cls'
   print "Liste des touches utilisables: \n";
   
   print "   +--------+----------+------------+------------+ \n";
   print "   | Touche | Bascule  |   Groupe   |   Bip      | \n";
   print "   +--------+----------+------------+------------+ \n";
   print "   |   $clavier[4]    |   OFF    |     1      |  5 longs   | \n";
   print "   |   $clavier[5]    |   OFF    |     2      |  5 longs   | \n";
   print "   |   $clavier[6]    |   OFF    |     3      |  5 longs   | \n";
   print "   |   $clavier[7]    |   OFF    |     4      |  5 longs   | \n";
   print "   +--------+----------+------------+------------+ \n";
   print "   +--------+----------+------------+------------+ \n";
   print "   |   $clavier[8]   |   ON     |     1      |  1 court   | \n";
   print "   |   $clavier[9]   |   ON     |     2      |  2 courts  | \n";
   print "   |   $clavier[10]   |   ON     |     3      |  3 courts  | \n";
   print "   |   $clavier[11]   |   ON     |     4      |  4 courts  | \n";
   print "   +--------+----------+------------+------------+ \n";
   print "   +--------+----------+------------+------------+ \n";
   print "   |   $clavier[12]   |   OFF    |   TOUS     | 10 courts  | <= Hor. Rouge \n";
   print "   |   $clavier[13]   |   OFF    | ALL < 16h  | 10 courts  | <= Hor. Blanc \n";
   print "   +--------+----------+------------+------------+ \n";
}

sub info
{
   system("clear");   # equ 'cls'
#  print "Gestion immdiate du chauffage, version $Version ";
#  print "Actuellement:\n";
   printf $messages[0], $Version;
   printf $messages[1];
   if ( -e $Fi_lock_ejp ) {
      printf $messages[4], "EJP";
   }
   if ( -e $Fi_lock_blanc ) {
      printf $messages[4], "BLANC";
   }
   system("/usr/bin/heathin");
}

sub touche
{
   my ($j, $k, $count);
   if ( $flag_err ) {
      print "\n$erreurs[$flag_err]\n"; 
   } else {
     print "\n";
   }
  $_ = $clavier[3];
  $k = s/.//; # Suppression du premier caractre
   printf $messages[2], $clavier[3];
   print "=>?\n";

   $key=ReadKey($timeout, *IN);
   if ( !$key ) {
      $key=" ";
      $ancien_etat=$etat;
      $etat=4;
   }
   $flag_err = 0;
}

# ------------------------------------------------------------------------------
# Extraction des donnes des fichiers de conf.
# ------------------------------------------------------------------------------

sub lectureconf
{
   open (FHT, $Fi_touches ) or die "Fichier des actions non trouv.\n";
   my $i=0;
   while( <FHT> ) {
      if ( $_ =~ /[#*]/ ) {
         # Un commentaire? On passe!
      } elsif ( $_ =~ /[:*]/ ) {
         # Dbut de commande, c'est le raccorcie clavier qui suit
         $clavier[$i] = $_;
         $clavier[$i] =~ s/://; # Suppression des ':'
      } elsif ( $_ =~ /[>*]/ ) {
         # C'est une commande, on insert dans le tableau, merci!

      } elsif ( $_ =~ /[\n]/ ) {
         # C'est une fin des commandes, on remet certaines variables  0;
         $i++;

      } else {
         # qu'est ce que c'est que ce bazard?

      }
   }
   chop @clavier; # on enleve tous les retours chariots des elements du tableau;
   close FHT;

}

sub lecturerreurs
{
   my $i=0;

   open (FHE, $Fi_erreurs) or die "Fichier des erreurs non trouv.\n";

   while( <FHE> ) {
      if ( $_ =~ /[#*]/ ) {
         # Un commentaire? On passe!
      } else {
         $erreurs[$i] = $_ ;
         $i++;
      }
   }
   close FHE;
}

sub lecturemessages
{
   my $i=0;


   open (FHM, $Fi_messages) or die "Fichier des messages non trouv.\n";

   while( <FHM> ) {
      if ( $_ =~ /[#*]/ ) {
         # Un commentaire? On passe!
      } else {
         $messages[$i] = $_ ;
         $i++;
      }
   }
   close FHM;
}


# ------------------------------------------------------
# Fin des fonctions et du programme tant qu'on y est!
# ------------------------------------------------------
